﻿/**
 * 파일 처리를 위한 오브젝트
 */
var FILEHANDLER = new ActiveXObject("Scripting.FileSystemObject");

/**
 * 파일 정보 갱신을 위한 오브젝트
 */
var SHELLHANDLER = new ActiveXObject("Shell.Application")

/**
 * AJAX 메인 오브젝트
 */
var m_objXmlHttp;

/**
 * 대상폴더를 생성해 주는 함수(대상폴더를 생성해 주는 함수로 대상의 상위폴더도 함께 생성해 준다.)
 * @param {string} strPath 생성할 폴더 풀경로
**/
function makeDirectory(strPath)
{
	var directories = strPath.split("\\");
	if(directories==undefined || directories==null || directories.length == 1)
	{
//		traceLog("##### :잘못된 인자로 폴더생성 실패");
		return;
	}
	var FsoNew = FILEHANDLER; //Write할 파일	
	var strDirectoryPath = directories[0];

	for(var depth = 1 ; depth < directories.length ; depth++)
	{
			strDirectoryPath+="\\"+directories[depth];	
			//factory.consoleprint(FsoNew.FolderExists(strDirectoryPath));
			if(FsoNew.FolderExists(strDirectoryPath)==false)
				FsoNew.CreateFolder(strDirectoryPath);
	}
}

/**
 * 디렉토리 내의 모든 파일과 하위 폴더를 삭제하는 함수
 * @param {string} strPath 삭제할 파일들이 있는 디렉토리 풀경로
**/
function deleteAllFilesAndFoldersInDirectory(strPath)
{
    var folder = FILEHANDLER.GetFolder(strPath);
    var files = new Enumerator(folder.Files);
    for (; !files.atEnd(); files.moveNext()) {
        FILEHANDLER.DeleteFile(files.item());
    }

    var subFolders = new Enumerator(folder.SubFolders);
    for (; !subFolders.atEnd(); subFolders.moveNext()) {
        deleteAllFilesAndFoldersInDirectory(subFolders.item().Path); // 하위 폴더 내 파일 및 폴더 삭제
        FILEHANDLER.DeleteFolder(subFolders.item().Path); // 하위 폴더 삭제
    }
}

/**
 * AJAX 개체를 만들어서 리턴하는 함수
 * HEAD 명령어를 이용해서 파일의 최종변경시간을 알기 위해서 사용한다.
 * @return {object} AJAX 처리용 객체를 리턴한다.
 */
function getXmlHttp()
{
	if( m_objXmlHttp != null ){ 
//		factory.consoleprint("[check] >>>>> :: m_objXmlHttp != null ");
		return m_objXmlHttp;
	}
			
	var objXmlHttp = null;
	var libs = new Array('MSXML4','MSXML3','MSXML2','Microsoft');
	for( var i = 0; i < libs.length; i++ ) 
	{
		try 
		{
			var libname = libs[i] + ".XMLHTTP";
			objXmlHttp = new ActiveXObject( libname );
			break;
		} 
		
		catch(e) 
		{
			continue;
		}
	}
	if (objXmlHttp == null)
	{	
		factory.consoleprint("[check] >>>>> :: m_objXmlHttp == null ");
		throw "XMLHttpRequest Object Not Create!.";
	}
	m_objXmlHttp = objXmlHttp;
	return objXmlHttp;
}

/**
 *
 */
function download_xFrame(ABaseUrl, AListName, ATargetDir)
{
	var arrFileInfo = [];
	
	var clsRnt = factory.httprequest(ABaseUrl + "/" + AListName, true, "", "");
	if (clsRnt.strrecvdata <= 0) {
		screen.alert("리스트 파일 다운로드 실패 주소를 확인하세요");
		return;
	}
	var sListFile = clsRnt.strrecvdata;
	webFileManager.deletealldownloadfile();
	var sBaseUrl = ABaseUrl + "/";
	var sBaseDir = ATargetDir + "\\";
	webFileManager.downloadoption(sBaseDir, 2, true, false, false, false);

	var arrData = sListFile.replace(/\r/g, "").split("\n");
	for (var i = 0, iDataLen = arrData.length;i < iDataLen;i++) {
		var objFileInfo = {url:"", filepath:"", installpath:"", filewrite:"", filetype:""};
		var arrOneData = arrData[i].split(",");
		var sFileUrl = sBaseUrl + arrOneData[0];
		var sLocalFileName = sBaseDir + arrOneData[0].replace(/\//g, "\\");
		var sLocalFilePath = sLocalFileName.split(/\\/).slice(0, -1).join("\\");
		makeDirectory(sLocalFilePath);
		objFileInfo["url"] = sFileUrl;
		objFileInfo["filepath"] = sLocalFileName;
		objFileInfo["installpath"] = arrOneData[0].replace(/\//g, "\\");
		if (arrOneData.length > 1 && arrOneData[1] != undefined) {
			objFileInfo["installpath"] = arrOneData[1].replace(/\//g, "\\");
		}
		if (arrOneData.length > 2 && arrOneData[2] != undefined) {
			objFileInfo["filewrite"] = arrOneData[2];
		}
		if (arrOneData.length > 3 && arrOneData[3] != undefined) {
			objFileInfo["filetype"] = arrOneData[3];
		}
		arrFileInfo.push(objFileInfo);
		webFileManager.adddownloadfile(arrOneData[0].replace(/\//g, "\\"), sFileUrl, "", "");
	}
	webFileManager.showdownloaddialogex(true, screen, true);
	factory.filewrite(sBaseDir + AListName, sListFile, XFD_FILEWRITE_OVERWRITE, "utf-8", false);
	
	for (var i = 0, iLen = arrFileInfo.length;i < iLen;i++) {
		changeFileModifyDate(arrFileInfo[i].url, arrFileInfo[i].filepath);
	}
	
	return arrFileInfo;
}

function changeFileModifyDate(AUrl, AFilePath)
{
	var sUrl = AUrl;
	var objAJAX = getXmlHttp();
	objAJAX.open("HEAD", sUrl, false);
	objAJAX.send();
	var strLastModified = objAJAX.getResponseHeader('Last-Modified');
	if (strLastModified != "") {
		if (factory.filefind(AFilePath)) {
			var fso = FILEHANDLER;
			var file = fso.GetFile(AFilePath);
		    var objFolder = SHELLHANDLER.NameSpace(file.ParentFolder.Path)
			var objFile = objFolder.ParseName(file.Name)
			var dtDate = new Date(strLastModified);
			var strDate = dtDate.toLocaleString().replace(/^(\d+)년\s(\d+)월\s(\d+)일\s.요일/, function(AFull, Var1, Var2, Var3) {
				return Var1 + "-" + Var2 + "-" + Var3;
			});
		    objFile.ModifyDate = strDate;
		} else {
			factory.consoleprint("파일 존재 않함:" + AFilePath);
		}
	} else {
		factory.consoleprint("변경일자 없음:" + AUrl);
	}
}

function screen_on_load()
{
	
}
 
function btnDownload_on_mouseup(objInst)
{
	if (edtxFrame5Url.gettext() == "") {
		screen.alert("서버 URL을 설정해주세요");
		edtxFrame5Url.setfocus();
		return;
	}
	if (edtxFrame5ListName.gettext() == "") {
		screen.alert("_listfile.txt 명을 지정하세요");
		edtxFrame5ListName.setfocus();
		return;
	}
	if (edtTargetDir.gettext() == "") {
		screen.alert("다운로드 디렉토리를 설정해주세요"); 
		edtTargetDir.setfocus();
		return;
	}
	
	var bContinue = screen.confirm("다운로드 위치의 모든 파일들이 삭제된 후 다운로드 됩니다");
	if (!bContinue) { return; }
	
    // 이미 파일이 있는경우 업데이트가 안되서, 다운로드 전에 기존 파일과 폴더 삭제
    deleteAllFilesAndFoldersInDirectory(edtTargetDir.gettext());

	// 모든 파일 삭제가 되었는지 확인하기 위해 1초 딜레이
	factory.sleep(1000);

	download_xFrame(edtxFrame5Url.gettext(), edtxFrame5ListName.gettext(), edtTargetDir.gettext());
	
	screen.alert("다운로드가 완료되었습니다");
}

function btnSetTargetDir_on_mouseup(objInst)
{
	var sDir = factory.showfolderdialog("", "다운로드 위치");
	if (sDir != "") {
		edtTargetDir.settext(sDir);
	}
}